/**
 * This Exception is raised when Formula fails in tokenizing or parsing the
 * formula.
 */
public class ParserException extends Exception {
    private boolean quiet;
    private String msg;
    /**
     * Contructor for ParserException.  By default, sets quiet to true.
     */
    public ParserException() { quiet = true; };
    /** Sets the exception message to the passed string
     * @param msg the error message string
     */
    public ParserException(String msg) { super(msg); this.msg = msg; };
    /** Sets the exception message to the passed object
     * @param msg the error object
     */
    public ParserException(Object msg) {
        super(msg.toString());
        this.msg = msg.toString();
    }
    /**
     * This returns the value of quiet.
     *
     * @return true if quiet is true, false otherwise
     */
    public boolean isQuiet() { return quiet; }
    /**
     * toString method for ParserException.
     *
     * @return the error message string
     */
    public String toString() { return msg; }
}