import java.awt.image.BufferedImage;
/**
 * Class: TerpClipboardInterface
 *
 * Description: This class helps us figure out which
 * TerpOffice application we are currently handling.
 *
 * @author Serey Lay
 * @version 1.0
 */
public interface TerpClipboardInterface {
    //these are contants that will be used to identify the source of the Object
    static int SPREADSHEET = 1;
    static int NOTEPAD = 2;
    static int OOD = 3;
    static int PAINT = 4;
    static int CALC = 5;
    static int INTEGRATOR = 6;
    /**
     * Gets the name of the TerpOffice app
     *
     * @return the TerpOffice app name
     */
    public String getString();
    /**
     * Gets the BufferedImage
     *
     * @return the BufferedImage
     * @see BufferedImage
     */
    public BufferedImage getImage();
    /**
     * Gets the TerpOffice app that is currently being handled
     *
     * @return  value of which app being handled
     */
    public int copiedFrom();  //returns one of the static constants
}
